#include <iostream>

using namespace std;

int main()
{
    int A, B, AB, O, n;
    bool moguce = true;
    cin >> n;
    cin >> O >> A >> B >> AB;
    int potrosnja[n][4];

    for (int i = 0; i < n; i++){
        string grupa;
        int potreba;
        cin >> grupa;
        cin >> potreba;

        for (int j = 0; j < 4; j++){
            for (int j1 = 0; j1 < 4; j1++){
                potrosnja[j][j1] = 0;
            }
        }

        if (grupa == "O"){
            if (potreba > O){
                moguce = false;
            }
            O -= potreba;
            potrosnja[i][0] = potreba;
            potreba = 0;
        }

        if (grupa == "A"){
            if (A >= potreba){
                A -= potreba;
                potrosnja[i][1] = potreba;
            }else{
                potreba -= A;
                potrosnja[i][1] = A;
                A = 0;
                if (potreba > O){
                    moguce = false;
                }
                O -= potreba;
                potrosnja[i][0] = potreba;
            }
        }

        if (grupa == "B"){
            if (B >= potreba){
                B -= potreba;
                potrosnja[i][2] = potreba;
            }else{
                potreba -= B;
                potrosnja[i][2] = B;
                B = 0;
                if (potreba > O){
                    moguce = false;
                }
                O -= potreba;
                potrosnja[i][0] = potreba;
            }
        }

        if (grupa == "AB"){
            if (AB >= potreba){
                AB -= potreba;
                potrosnja[i][3] = potreba;
            }else{
                potreba -= AB;
                potrosnja[i][3] = AB;
                AB = 0;
                if (A >= potreba){
                    A -= potreba;
                    potrosnja[i][1] = potreba;
                }else{
                    potreba -= A;
                    potrosnja[i][1] = A;
                    A = 0;
                    if (B >= potreba){
                        B -= potreba;
                        potrosnja[i][2] = potreba;
                    }else{
                        potreba -= B;
                        potrosnja[i][2] = B;
                        B = 0;
                        if (potreba > O){
                            moguce = false;
                        }
                        O -= potreba;
                        potrosnja[i][0] = potreba;
                    }
                }
            }
        }
    }

    if (moguce){
        cout << "moguce\n";
        for (int i = 0; i < n; i++){
            for (int j = 0; j < 4; j++){
                cout << potrosnja[i][j];
            }
            cout << "\n";
        }
    }else{
        cout << "nemoguce";
    }
}